/*
 * heat2d-band.c --- 2Ǯ򱢲ˡǲ (ӹ)
 *   ѥ뤹ˤ
 *     gcc -c bandlu.c
 *     gcc -o heat2d-band heat2d-band.c bandlu.o -lmatrix -lglscd -lX11 -lm
 *   뤤 6701 漼ʤ
 *     ccmg heat2d-band.c bandlu.o
 */

/*
 *  AϡȾХmӹǤΤǡѤ
 * ϢΩ򤯤Τ®+ʥ경롣
 * ĤޤꡢӤʬФƷ׻Ƥ
 * η(a_{i,j})ȤȡФAȤδط,
 *   A[i][j] = a_{i,i+j-m}  (m  i+j < m+n)
 *           = 0            (i+j < m ޤ m+n  i+j)
 * ޤϡ
 *   a_{i,j} = A[i][j-i+m]  (0  j-i+m < 2m+1)
 *
 * : ȾХ m ǤȤϡ
 *   |i-j|>m => a_{i,j}=0
 * ȤȤǤ롣
 * ȾХ=0ʤгѹȾХ=1ʤлгѹ
 */

#include <stdio.h>
#include <math.h>
#include <matrix.h>
#define G_DOUBLE
#include <glsc.h>
#include "bandlu.h"

#define phi(i,j) (j)*m+(i)

int main()
{
    double a, b, c, d;
    int N_x, N_y, m, N, i, j, p, q, L, n, nMax;
    matrix Uk, A;
    double *B, *vector_U;
    int skip;
    double h_x, h_y, lambda_x, lambda_y, lambda, lambda_limit, tau,
     Tmax, dt;
    double f(double, double), alpha(double, double);
    double theta, beta_0, beta_1, beta_2, beta_00, beta_10, beta_20;
    double x, y;

    a = 0.0; b = 1.0; c = 0.0; d = 1.0;

    printf("Nx, Ny: ");
    scanf("%d %d", &N_x, &N_y);

    m = N_x + 1;
    N = (N_x + 1) * (N_y + 1);
    h_x = (b - a) / N_x;
    h_y = (d - c) / N_y;

    if ((Uk = new_matrix(N_x + 1, N_y + 1)) == NULL) {
        fprintf(stderr, " U^k 򵭲ΰγݤ˼\n");
        exit(1);
    }
    if ((A = new_matrix(N, (2 * m + 1))) == NULL) {
        fprintf(stderr, " A 򵭲ΰγݤ˼\n");
        exit(1);
    }
    if ((B = (double *) malloc(sizeof(double) * N)) == NULL) {
        fprintf(stderr, "B 򵭲ΰγݤ˼\n");
        exit(1);
    }
    if ((vector_U = (double *) malloc(sizeof(double) * N)) == NULL) {
        fprintf(stderr, "vector_U 򵭲ΰγݤ˼\n");
        exit(1);
    }
    printf(" (0ȡ1): ");
    scanf("%lf", &theta);

    if (theta == 1.0) {
        printf(": ");
        scanf("%lf", &tau);
    } else {
        printf("(%g): ",
               0.5 / (1 - theta) / (1 / (h_x * h_x) + 1 / (h_y * h_y)));
        scanf("%lf", &tau);
    }

    lambda_x = tau / (h_x * h_x);
    lambda_y = tau / (h_y * h_y);
    lambda = lambda_x + lambda_y;

    lambda_limit = 1.0 / (2.0 * (1.0 - theta));

    if (lambda > lambda_limit)
        printf(": =%g>1/2(1-) ȤʤäƤޤ\n", lambda);

    for (i = 0; i <= N_x; i++)
        for (j = 0; j <= N_y; j++)
            Uk[i][j] = f(a + i * h_x, c + j * h_y);

    beta_0 = 1.0 + 2.0 * theta * lambda;
    beta_1 = -theta * lambda_x;
    beta_2 = -theta * lambda_y;

    beta_00 = 1.0 - 2.0 * (1.0 - theta) * lambda;
    beta_10 = (1.0 - theta) * lambda_x;
    beta_20 = (1.0 - theta) * lambda_y;

    for (p = 0; p < N; p++) {
        for (q = 0; q < 2 * m + 1; q++)         /* N */
            A[p][q] = 0.0;      /*A[p][q] = 0.0; */
        A[p][m] = 1.0;          /*A[p][p] = 1.0; */
    }
    for (i = 1; i < N_x; i++)
        for (j = 1; j < N_y; j++) {
            L = phi(i, j);
            A[L][L - m - L + m] = beta_2;       /*A[L][L - m] = beta_2; */
            A[L][L - 1 - L + m] = beta_1;       /*A[L][L - 1] = beta_1; */
            A[L][L - L + m] = beta_0;   /*A[L][L] = beta_0;    */
            A[L][L + 1 - L + m] = beta_1;       /*A[L][L + 1] = beta_1; */
            A[L][L + m - L + m] = beta_2;       /*A[L][L + m] = beta_2; */
        }

#ifdef  PRINT
    printf("Ѥ˺äϢΩ1ι\n");
    for (p = 0; p < N; p++) {
        for (q = 0; q < 2 * m + 1; q++)
            printf(" %+7.5f", A[p][q]);
        printf("\n");
    }
#endif

    /* оβ뤿κ 1 */
    for (j = 1; j < N_y; j++) {
        /* (1,j) */
        L = phi(1, j);
        A[L][L - 1 - L + m] = 0.0;      /*A[L][L - 1] = 0.0; */
        /* (N_x-1,j) */
        L = phi(N_x - 1, j);
        A[L][L + 1 - L + m] = 0.0;      /*A[L][L + 1] = 0.0; */
    }

    /* оβ뤿κ 2 */
    for (i = 1; i < N_x; i++) {
        /* (i,1) */
        L = phi(i, 1);
        A[L][L - m - L + m] = 0.0;      /*A[L][L - m] = 0.0; */
        /* (N_x-1,j) */
        L = phi(i, N_y - 1);
        A[L][L + m - L + m] = 0.0;      /*A[L][L + m] = 0.0; */
    }

#ifdef  PRINT
    printf("оβϢΩ1ι\n");
    for (p = 0; p < N; p++) {
        for (q = 0; q < 2 * m + 1; q++)
            printf(" %+7.5f", A[p][q]);
        printf("\n");
    }
#endif

    printf(": 1+2Ȧ=%4.1f, -Ȧx=%5.1f, -Ȧy=%5.1f\n",
           beta_0, beta_1, beta_2);

    printf("Tmax: ");
    scanf("%lf", &Tmax);
    printf("t: ");
    scanf("%lf", &dt);
    skip = rint(dt / tau);
    if (skip == 0) {
      skip = 1;
    }
    dt = skip * tau;

    nMax = rint(Tmax / tau);

    g_init("Meta", 250.0, 160.0);
    g_device(G_BOTH);
    g_def_scale(0, 0.0, 1.0, 0.0, 1.0, 30.0, 70.0, 100.0, 72.0);
    g_def_scale(4, -1.0, 1.0, -1.0, 1.0, 30.0, 30.0, 100.0, 100.0);
    g_def_line(0, G_BLACK, 0, G_LINE_SOLID);
    g_sel_scale(0);

    g_cls();
    g_hidden2(1.0, 1.0, 0.4, -1.0, 1.0, 5.0, 25.0, 20.0, 20.0, 20.0,
              150.0, 100.0, Uk, N_x + 1, N_y + 1,
              1, G_SIDE_NONE, 2, 1);

    /* LUʬ򤹤 */
    bandlu(N, m, A);            /* decomp(N, A, &cond, iwork, B); */

    for (n = 1; n <= nMax; n++) {

        /* ޤѤϢΩ켡αդѰդ */
        /* γʻ */
        for (i = 1; i < N_x; i++)
            for (j = 1; j < N_y; j++) {
                L = phi(i, j);
                B[L] = beta_00 * Uk[i][j]
                    + beta_10 * (Uk[i + 1][j] + Uk[i - 1][j])
                    + beta_20 * (Uk[i][j + 1] + Uk[i][j - 1]);
            }
        /* ադˤʻ (Ѥޤ) */
        for (i = 0; i <= N_x; i++) {
            x = a + i * h_x;
            /* (i, 0) */
            L = phi(i, 0);
            B[L] = alpha(x, c);
            /* (i, N_y) */
            L = phi(i, N_y);
            B[L] = alpha(x, d);
        }
        /* ադˤʻ (Ѥϴޤʤ) */
        for (j = 1; j < N_y; j++) {
            y = c + j * h_y;
            /* (0, j) */
            L = phi(0, j);
            B[L] = alpha(a, y);
            /* (N_x, j) */
            L = phi(N_x, j);
            B[L] = alpha(b, y);
        }

        /* оβ */
        /* оβ뤿κ 1 */
        for (j = 1; j < N_y; j++) {
            y = c + j * h_y;
            /* (1,j) */
            L = phi(1, j);
            B[L] -= beta_1 * alpha(a, y);
            /* (N_x-1,j) */
            L = phi(N_x - 1, j);
            B[L] -= beta_1 * alpha(b, y);
        }
        /* оβ뤿κ 2 */
        for (i = 1; i < N_x; i++) {
            x = a + i * h_x;
            /* (i,1) */
            L = phi(i, 1);
            B[L] -= beta_2 * alpha(x, c);
            /* (i,N_y-1) */
            L = phi(i, N_y - 1);
            B[L] -= beta_2 * alpha(x, d);
        }

        /* A vector_U = B  */
        bandsol(N, m, A, B);    /* solve(N, A, B, iwork); */
        /* */
        for (i = 0; i <= N_x; i++)
            for (j = 0; j <= N_y; j++)
                Uk[i][j] = B[phi(i, j)];
        /* */
        if (n % skip == 0) {
#ifdef  PRINT
            printf("%15.8f\n", n * dt);
            for (i = 0; i <= N_x; i++) {
                for (j = 0; j <= N_y; j++)
                    printf(" %+7.5f", Uk[i][j]);
                printf("\n");
            }
#endif

            g_cls();
            g_hidden2(1.0, 1.0, 0.4, -1.0, 1.0, 5.0, 25.0, 20.0, 20.0, 20.0,
                      150.0, 100.0, Uk, N_x + 1, N_y + 1,
                      1, G_SIDE_NONE, 2, 1);
        }
    }
    /* ޥǥåΤԤ */
    g_sleep(-1.0);
    /* ɥä */
    g_term();

    return 0;
}

double f(double x, double y)
{
    /* ԥߥåɷδؿ */
    if (y > 0.5)
        y = 1 - y;
    if (x > 0.5)
        x = 1 - x;
    if (y < x)
        return 5 * y;
    else
        return 5 * x;
}

double alpha(double x, double y)
{
    /* Ʊ Dirichlet  */
    return 0.0;
}
